<template>
  <router-link class="link" :to="to">
    <font-awesome-icon class="icon" :icon="icon" />
    <div class="name">{{ name }}</div>
    <div class="filler"></div>
    <div v-if="unread_count > 0" class="unread">{{ unread_count }}</div>
  </router-link>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { IconDefinition } from "@fortawesome/free-solid-svg-icons";

@Options({
  components: {
    FontAwesomeIcon,
  },
  props: {
    to: String,
    name: String,
    unread_count: Number,
    icon: Object,
  },
})
export default class NavigationLink extends Vue {
  public to!: string;
  public name!: string;
  public icon!: IconDefinition;

  public unread_count = 0;
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.link {
  display: flex;
  padding: 15px 25px;
  text-decoration: none;
  color: $black_text;
  font-size: 16px;
  font-weight: bold;

  &:hover {
    background-color: $light_hover;
  }

  &.router-link-active {
    background-color: $white_bg;
    box-shadow: -3px 0px 3px 0px $shadow_grey;
  }
  .icon {
    width: 18px;
    font-size: 18px;
  }
  .name {
    margin-left: 15px;
  }
  .filler {
    flex-grow: 1;
  }
  .unread {
    background-color: $red;
    color: white;
    font-size: 14px;
    padding: 1px 8px 1px 7px;
    border-radius: 20px;
    font-weight: bold;
  }
}
</style>
